/*
 * KEALogger.java  -  This file is part of KEA.
 *
 * Copyright (C) 2002/03 PG 419, Department of Computer Science, 
 * University of Dortmund.          eMail: <peter.senft@udo.edu>
 */

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the KEA License Agreement which is based on 
 * the GNU General Public License as published by the Free Software 
 * Foundation; either version 2 of the License, or (at your option) 
 * any later version.  For details see License.txt.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 */
 
package kea;

import java.util.logging.Level;
import java.util.logging.Logger;

//import java.util.logging.Logger;
/**
 * This is a wrapper class that provides some basic functions of the log4j package.
 * If you are a developer and you want to implement a module for KEA you may be
 * wanting to use some of the logging features of KEA because it can be very useful
 * for you and the user of your module.
 *
 * @author Norman Welp
 * @version $Revision 1.1$
 */
public class KEALogger {

	//private static KEALogger instance;
	private java.util.logging.Logger logger;
	private String loggerName;


	/**
	 * Private constructor which is called by getInstance() if no instance
	 * of KEALogger exists at the current time. <p>
	 * @param String loggerName The name of the logger<p>
	 * @return a KEALogger brandnew instance
	 */
	private KEALogger(String loggerName){
			this.loggerName=loggerName;
			logger = Logger.getLogger(loggerName);
			//we configute log4j by reading log4j.properties every 5(000) (milli)seconds
			//System.out.println(url.toString());
	
	
	
	}

	/**
	 * This method retrieves an instance of the KEALogger. <p>
	 * Normally you want to call it with this.class.getName() as parameter.
	 * @param String logger	The name of the logger
	 * @return A KEALogger instance
	 */
	static public KEALogger getInstance(String logger){
		System.out.println("parameter logger="+logger);
		return new KEALogger(logger);
	}

	/**
	* Log method for debug level
	* @param String msg	The message to be printed
	*/
	public void logDebug(String msg){
//		logger.log(Level.INFO,msg);
	}

	/**
	* Log method for debug level
	* @param Object o The reference to th calling class
	* @param String msg	The message to be printed
	*/
	public void logDebug(String msg, Object o){
//		logger.log(Level.INFO,msg);
	}

	/**
	* Log method for error level
	* @param String msg	The message to be printed
	*/
	public void logError(String msg){
//		logger.log(Level.WARNING,msg);
	}

		/**
	* Log method for error level
	* @param Object o The reference to th calling class
	* @param String msg	The message to be printed
	*/
	public void logError(String msg, Object o){
//		logger.log(Level.INFO,msg);
	}

	/**
	* Log method for fatal level
	* @param String msg	The message to be printed
	*/
	public void logFatal(String msg){
//		logger.log(Level.INFO,msg);
	}

		/**
	* Log method for fatal level
	* @param String msg	The message to be printed
	* @param Object o The reference to th calling class
	*/
	public void logFatal(String msg, Object o){
//		logger.log(Level.INFO,msg);
	}


	/**
	* Log method for info level
	* @param String msg	The message to be printed
	*/
	public void logInfo(String msg){
//		logger.info(msg);
	}

	/**
	* Log method for info level
	* @param String msg	The message to be printed
	* @param Object o The reference to th calling class
	*/
	public void logInfo(String msg, Object o){
//		logger.log(Level.INFO,msg);
	}


	/**
	* Log method for warn level
	* @param String msg	The message to be printed
	*/
	public void logWarn(String msg){
//		logger.log(Level.INFO,msg);
	}

		/**
	* Log method for warn level
	* @param String msg	The message to be printed
	* @param Object o The reference to th calling class
	*/
	public void logWarn(String msg, Object o){
//		logger.log(Level.INFO,msg);
	}


	/**
	* Log method for debug level
	* @param String msg	The message to be printed
	* @param Throwable t A throwable object (e.g. an exception)
	*/
	public void logDebug(String msg, Throwable t){
//		logger.log(Level.INFO,msg, t);
	}

	/**
	* Log method for error level
	* @param String msg	The message to be printed
	* @param Throwable t A throwable object (e.g. an exception)
	*/
	public void logError(String msg, Throwable t){
//		logger.log(Level.INFO,msg, t);
	}

	/**
	* Log method for fatal level
	* @param String msg	The message to be printed
	* @param Throwable t A throwable object (e.g. an exception)
	*/
	public void logFatal(String msg, Throwable t){
//		logger.log(Level.INFO,msg, t);
	}

	/**
	* Log method for info level
	* @param String msg	The message to be printed
	* @param Throwable t A throwable object (e.g. an exception)
	*/
	public void logInfo(String msg, Throwable t){
//		logger.log(Level.INFO,msg, t);
	}

		/**
	* Log method for warn level
	* @param String msg	The message to be printed
	* @param Throwable t A throwable object (e.g. an exception)
	*/
	public void logWarn(String msg, Throwable t){
//		logger.log(Level.INFO,msg, t);
	}

		/**
	* Log method for debug level
	* @param String msg	The message to be printed
	* @param Object o The reference to th calling class
	* @param Throwable t A throwable object (e.g. an exception)
	*/
	public void logDebug(String msg, Throwable t, Object o){
//		logger.log(Level.INFO,msg, t);
	}

	/**
	* Log method for error level
	* @param String msg	The message to be printed
	* @param Object o The reference to th calling class
	* @param Throwable t A throwable object (e.g. an exception)
	*/
	public void logError(String msg, Throwable t, Object o){
//		logger.log(Level.INFO,msg, t);
	}

	/**
	* Log method for fatal level
	* @param String msg	The message to be printed
	* @param Object o The reference to th calling class
	* @param Throwable t A throwable object (e.g. an exception)
	*/
	public void logFatal(String msg, Throwable t, Object o){
//		logger.log(Level.INFO,msg, t);
	}

	/**
	* Log method for info level
	* @param String msg	The message to be printed
	* @param Object o The reference to th calling class
	* @param Throwable t A throwable object (e.g. an exception)
	*/
	public void logInfo(String msg, Throwable t, Object o){
//		logger.log(Level.INFO,msg, t);
	}

		/**
	* Log method for warn level
	* @param String msg	The message to be printed
	* @param Object o The reference to th calling class
	* @param Throwable t A throwable object (e.g. an exception)
	*/
	public void logWarn(String msg, Throwable t, Object o){
//		logger.log(Level.INFO,msg, t);
	}

	/**
	 * Determines whether or not debug level log is enabled
	 * @return true if enabled, else false
	 */
	public boolean debugOn(){
	return logger.isLoggable(Level.ALL);
	}


	/**
	 * Determines whether or not info level log is enabled
	 * @return true if enabled, else false
	 */
	public boolean infoOn(){
		return logger.isLoggable(Level.INFO);
	}


}
