/*
 * Parameter.java  -  This file is part of KEA.
 *
 * Copyright (C) 2002/03 PG 419, Department of Computer Science, 
 * University of Dortmund.          eMail: <peter.senft@udo.edu>
 */

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the KEA License Agreement which is based on 
 * the GNU General Public License as published by the Free Software 
 * Foundation; either version 2 of the License, or (at your option) 
 * any later version.  For details see License.txt.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 */

package kea;

import java.io.Serializable;

/**
 * @author Stefan Kusper, Peter Senft, Norman Welp
 * @version 0.1.0
 */
public class Parameter extends kea.Value implements Serializable{

    public Parameter() {
	super();
	this.name = "";
	this.toolTip = "";
    }

    public Parameter(String name, Value val, String toolTip) {
	super((Object)val);
	this.name = name;
	this.toolTip = toolTip;
    }

    public Parameter(String name, Object val, String toolTip) {
        super(val);
	this.name = name;
	this.toolTip = toolTip;
    }

    public Parameter(String name, Boolean val, String toolTip) {
	super(val);
	this.name = name;
	this.toolTip = toolTip;
    }

    public Parameter(String name, Integer val, String toolTip) {
	super(val);
	this.name = name;
	this.toolTip = toolTip;
    }

    public Parameter(String name, Short val, String toolTip) {
	super(val);
	this.name = name;
	this.toolTip = toolTip;
    }

    public Parameter(String name, Byte val, String toolTip) {
	super(val);
	this.name = name;
	this.toolTip = toolTip;
    }

    public Parameter(String name, Character val, String toolTip) {
	super(val);
	this.name = name;
	this.toolTip = toolTip;
    }

    public Parameter(String name, Double val, String toolTip) {
	super(val);
	this.name = name;
	this.toolTip = toolTip;
    }

    public Parameter(String name, Long val, String toolTip) {
	super(val);
	this.name = name;
	this.toolTip = toolTip;
    }

    public Parameter(String name, Float val, String toolTip) {
	super(val);
	this.name = name;
	this.toolTip = toolTip;
    }

    public Parameter(String name, boolean val, String toolTip) {
	super(val);
	this.name = name;
	this.toolTip = toolTip;
    }

    public Parameter(String name, int val, String toolTip) {
	super(val);
	this.name = name;
	this.toolTip = toolTip;
    }

    public Parameter(String name, short val, String toolTip) {
	super(val);
	this.name = name;
	this.toolTip = toolTip;
    }

    public Parameter(String name, long val, String toolTip) {
	super(val);
	this.name = name;
	this.toolTip = toolTip;
    }

    public Parameter(String name, byte val, String toolTip) {
	super(val);
	this.name = name;
	this.toolTip = toolTip;
    }

    public Parameter(String name, char val, String toolTip) {
	super(val);
	this.name = name;
	this.toolTip = toolTip;
    }

    public Parameter(String name, double val, String toolTip) {
	super(val);
	this.name = name;
	this.toolTip = toolTip;
    }

    public Parameter(String name, float val, String toolTip) {
	super(val);
	this.name = name;
	this.toolTip = toolTip;
    }

    public Parameter(String name, String val, String toolTip) {
	super(val);
	this.name = name;
	this.toolTip = toolTip;
    }

    public String getName(){
	return name;
    }
    
    public String getToolTip(){
	return toolTip;
    }
    
    public void setName(String name){
	this.name = name;
    }
    
    public void setToolTip(String toolTip){
	this.toolTip = toolTip;
    }
    
    public String toString() {
        String retval = new String();
	
	retval = this.name;
	retval = retval + " = " + super.toString();
	retval = retval + " # " + this.toolTip;
	
        return retval;
    }

    private String name;
    private String toolTip;
}
