/*
 * RunTypes.java  -  This file is part of KEA.
 *
 * Copyright (C) 2002/03 PG 419, Department of Computer Science, 
 * University of Dortmund.          eMail: <peter.senft@udo.edu>
 */

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the KEA License Agreement which is based on 
 * the GNU General Public License as published by the Free Software 
 * Foundation; either version 2 of the License, or (at your option) 
 * any later version.  For details see License.txt.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 */

package kea;

/**
 * Actiontyp Class for KEA. The Parser finds out with which command properties the user
 * starts the system. KEA can then start the requested operations, the possibilities are:<p>
 *
 * - RUN_ALGOSTATE (int 0) KEA finishes a former halted Optimisation rum<p>
 *
 * - RUN_ALGOANDPROB (int 1) KEA solves a given problem with a given alorithem<p>
 *
 * - RUN_COMPARISON (int 2) KEA compares resukts<p>
 *
 * - RUN_EVALUATION (int 3) KEA evaluates results<p>
 *
 * - RUN_MAKEDEFAULT(int 4) KEA creates deafaut Parameter Files <p>
 *
 * - RUN_KEACONF (int 5)<p>
 *
 * @author Torsten Kohlen
 * @version 0.1.0
 */
public class RunTypes {
    public static final int RUN_ALGOSTATE   = 0;
    public static final int RUN_ALGOANDPROB = 1;
    public static final int RUN_COMPARISON  = 2;
    public static final int RUN_EVALUATION  = 3;
    public static final int RUN_MAKEDEFAULT = 4;
    public static final int RUN_KEACONF     = 5;
}
