/*
 * Hypercube.java  -  This file is part of KEA.
 *
 * Copyright (C) 2002/03 PG 419, Department of Computer Science, 
 * University of Dortmund.          eMail: <peter.senft@udo.edu>
 */

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the KEA License Agreement which is based on 
 * the GNU General Public License as published by the Free Software 
 * Foundation; either version 2 of the License, or (at your option) 
 * any later version.  For details see License.txt.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 */

package kea.algorithms.populationBased.dops;

import java.io.Serializable;

/**
 * The dops algorithm. <br>
 * This class implements a hypercube in the objective space and is used as a hash key
 * 
 * @author Philipp Limbourg
 * @version 0.1.0
 */
public class Hypercube implements Serializable{

  public Hypercube(double[] edgelength, double[] particlePosition) {
    cube=new int[particlePosition.length];
    for (int i = 0; i < cube.length; i++) {
      cube[i]=(int)(particlePosition[i]/edgelength[i]);
    }

  }
  public int hashCode() {
    int erg=1;
    for (int i = 0; i < cube.length; i++) {
      erg*=cube[i];
    }

    return erg;
  }
  public boolean equals (Object o) {
    Hypercube c=(Hypercube)o;
    for (int i = 0; i < cube.length; i++) {
      if (cube[i]!=c.cube[i]) {
	return false;
      }
    }
    return true;
  }
  int[] cube;
}
