/*
 * Copyright (C) 2005  PG447 - University Dortmund
 * 
 * This file is part of NObELTJE.
 * 
 * NObELTJE is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 * 
 * NObELTJE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with NObELTJE; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

 /*
 * Created on 28.06.2004
 */
package org.nobeltje.algo;

/**
 * @author $Author: noot $
 * @version $Revision: 726 $
 * $Date: 2005-02-02 00:50:20 +0100 (Mi, 02 Feb 2005) $
 */

public interface AlgoInterface {
	
	/**
	 * Start-Routine des Algos. Wird von main-Methode der Algo-Klasse aufgerufen.
	 * Dieser ?bernimmt die gesamte Berechnung des Algos, d.h. ruft alle n?tigen
	 * Methoden auf.
	 * Hieraus wird h?chstens der LiveOutput aufgerufen, der 'grosse' Output jedoch
	 * von der Routine gestartet, die auch diese Methode 'startAlgo()' aufruft.  
	 * Beim Implementieren bitte am Ende der Methode ein test.finalize() einfuegen, damit 
	 * der Temperierbohrungssimulator auch ohne Fehlermeldung beendet werden kann.
	 */
	public boolean startAlgo() throws Exception;
	
	
	/**
	 * Main Methode fuer den Aufruf des Algos
	 * 
	 * @param Parameter des Aufrufs
	 */
	//public void main(String[] args);
	

}
