/*
 * Copyright (C) 2005  PG447 - University Dortmund
 * 
 * This file is part of NObELTJE.
 * 
 * NObELTJE is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 * 
 * NObELTJE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with NObELTJE; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

 /*
 * Created on Jul 8, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package org.nobeltje.analysis;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Properties;

import org.nobeltje.metrics.Metric;
import org.nobeltje.tools.io.ArgsInputBeautifier;
import org.nobeltje.tools.io.FileParser;
import org.nobeltje.exceptions.MalInputFormatException;

/**
 * @author $Author: noot $
 * @version $Revision: 726 $
 * $Date: 2005-02-02 00:50:20 +0100 (Mi, 02 Feb 2005) $
 */
public class Metrics_Plotter_SMS_EMOA_pg
{
	/**
	 * <p>ist ein String, der den Namen der Ausgabedatei enth?lt, in die die
	 * einzelnen Durchl?ufe des Designs mit dem jeweils zugeh?rigen Wert aus der Metrik geschrieben
	 * werden.</p>
	 */
	private String outputFile;
	/**
	 * <p>enth?lt den Namen der zu benutzenden Metrik. Dieser wird vom MetricsPlotter automatisch um den 
	 * passenden Paketnamen .metrics erg?nzt.</p>
	 */
	private String metricName;

	
	private String testfkt;
	/**
	 * <p>in diesem Verzeichnis wird nach Dateien mit der Endung .res gesucht, die dann vom MetricsPlotter
	 * ausgewertet werden.</p>
	 */
	private File dir;

	/**
	 * Der MetricsPlotter dient zur Erstellung einfacher 2-D Balkendiagrammen, die dazu dienen sollen
	 * eine ?bersicht ?ber die einzelnen Algorithmenaufrufe zu schaffen und deren Effektivit?t
	 * grafisch darzustellen.
	 * 
	 * @param args Enth?lt die Kommandozeilenparameter
	 * @see tools.io.ArgsInputBeautifier
	 */
	public Metrics_Plotter_SMS_EMOA_pg(String []args)
	{
		try {
			Properties input = ArgsInputBeautifier.beautify(args);
			outputFile = ArgsInputBeautifier.getStringProperty(input, "o", "MetricPlotData.plt", false);
			metricName = ArgsInputBeautifier.getStringProperty(input, "m", "", true);
			testfkt = ArgsInputBeautifier.getStringProperty(input, "t", "", true);
			dir = new File(ArgsInputBeautifier.getStringProperty(input, "d", "", true));
			
			if (!dir.exists()) {
				System.err.println("Verzeichnis nicht vorhanden");
				System.exit(1);
			}

			// Hole aus dem angegebenen Verzeichnis alle Dateinamen mit der
			// Endung die im Fitness Filter festgelegt ist
			File fitnessFiles[] = dir.listFiles(new FitnessFilter());
			
			for (int i = 0; i < fitnessFiles.length; i++)
				System.out.println(fitnessFiles[i].getName());

			try {
				// Schreibe den Header fuer die Gnuplot Datei
				FileWriter fwPng = new FileWriter("png_"+outputFile, false);
				FileWriter fw = new FileWriter(""+outputFile, false);
				fw.write("set title '" + metricName + " " + dir + "'\n");
				fwPng.write("set title '" + metricName + " " + dir + "'\n");
				fw.write("set nokey\n");
				fwPng.write("set nokey\n");
				fw.write("set data style boxes\n\n");
				fwPng.write("set data style boxes\n\n");
				String nameWithNewSuffix = outputFile.replaceAll(".plt", ".png");
				fwPng.write("set term png\n");
				fwPng.write("set output \"" + nameWithNewSuffix + "\"\n" );
				fw.write("plot '-'\n");
				fwPng.write("plot '-'\n");

				// Binde die Metrikenklasse anhand des Namens an
				Metric metric = (Metric)Class.forName("metrics." + metricName).newInstance();
				System.out.println("metricName"+ metricName);
				
				// Rufe die Metrik fuer jede Datei auf
				List fitnessValues = new ArrayList();
				String trueParetoList = new String();
				for (int i = 0; i < fitnessFiles.length; i++) {
					System.out.println("ForSchleife?");
					// Lese die Fitness Werte ein
					FileParser.parseFile(fitnessFiles[i].getAbsolutePath(), fitnessValues);
					// Schreibe das Ergebnis der Metrik in eine Ausgabedatei
					double metricValue = 0.0;
					String a = new String("EuklidMetric");
					if(metricName.equals(a)){
						System.out.println("bin in EuklidMetrik");
					  String zdt = new String("/home/tipura/eclipse-3.0/pg447/testfkt/"+testfkt+"-1000.pareto");
					  System.out.println(zdt+" = ZDT");
					  File paretoFile = new File(zdt);
					 
					  System.out.println("mit der ZDT-Datei: "+paretoFile.getName());
					  List paretoList = new ArrayList();
					  /*if(testfkt == "ZDT1"){
					      trueParetoList = "zdt1-1000.pareto";
					  }
					  if(testfkt == "ZDT2"){
					      trueParetoList = "zdt2-1000.pareto";
					  }
					  if(testfkt == "ZDT3"){
					      trueParetoList = "zdt3-1000.pareto";
					  }
					  if(testfkt == "ZDT4"){
					      trueParetoList = "zdt4-1000.pareto";
					  }
					  if(testfkt == "ZDT6"){
					      trueParetoList = "zdt6-1000.pareto";
					  }*/
					  paretoFile = paretoFile.getAbsoluteFile();
					  System.out.println("mit der ZDT-Datei: "+paretoFile.getPath());
					  if (!paretoFile.exists()) {
						System.err.println("Verzeichnis oder ZDT nicht vorhanden");
						System.exit(1);
					  }
					  FileParser.parseFile(paretoFile.getAbsolutePath(), paretoList);
					  
					  metricValue = metric.computeMetric(fitnessValues,paretoList);  
					}
					if(metricName.equals("SMetricFleischer")){
						System.out.println("Fleischer?");
					    List refPoint = new ArrayList();
					    refPoint.add(new Double(1.1));
					    refPoint.add(new Double(1.1));
					    metricValue = metric.computeMetric(fitnessValues, refPoint);
					}
									
					fw.write(metricValue + "\n");
					System.out.println("?berhaupt Metrik?");
					fwPng.write(metricValue + "\n");
				}
				fw.write("e\n");
				fwPng.write("e\n");
				fw.close();
				fwPng.close();

				// Gnuplot aus Java aufrufen
				//visualizationProcess = Runtime.getRuntime().exec("gnuplot -persist");
				try {
					System.out.println("gnuplot -persist "+ "png_"+outputFile);
					Process visualizationProcess = Runtime.getRuntime().exec("gnuplot -persist "+ "png_"+outputFile);
					System.out.println("ende von gnuplot");
					//PrintStream gnuStream = new PrintStream(visualizationProcess.getOutputStream());
				}
				catch(Exception e){
					e.printStackTrace();
				}
				try {
					System.out.println("gnuplot -persist "+ outputFile);
					Process visualizationProcess = Runtime.getRuntime().exec("gnuplot -persist "+ outputFile);
					System.out.println("ende von gnuplot");
					//PrintStream gnuStream = new PrintStream(visualizationProcess.getOutputStream());
				}
				catch(Exception e){
					e.printStackTrace();
				}
			}

			// Fehler bei nicht gefundener Algo-Klasse ausgeben und abbrechen
			catch (ClassNotFoundException cnfe){
				System.err.println("\nFEHLER: Angegebene Algo-Klasse konnte nicht gefunden werden.\n");
				cnfe.printStackTrace();
				System.exit(1);	// Direkter Abbruch des Programms
			}
			// Fehler bei unzulaessiger Algo-Klasse ausgeben und abbrechen
			catch (ClassCastException cce){
				System.err.println("\nFEHLER: Angegebene Algo-Klasse ist nicht zulaessig (Cast-Fehler).\n");
				cce.printStackTrace();
				System.exit(1);	// Direkter Abbruch des Programms
			} 
			catch (NoSuchMethodException nsme) {
				System.err.println("\nFEHLER: Metrik wurde falsch angegeben.\n");
				nsme.printStackTrace();
				System.exit(1);	// Direkter Abbruch des Programms
			}
			catch (FileNotFoundException fnfe) {
				System.err.println("\nFEHLER: Metrik wurde falsch angegeben.\n");
				fnfe.printStackTrace();
				System.exit(1);	// Direkter Abbruch des Programms
			}
			catch (IOException ioe) {
				System.err.println("\nFEHLER: Metrik wurde falsch angegeben.\n");
				ioe.printStackTrace();
				System.exit(1);	// Direkter Abbruch des Programms
			}
			catch (Exception e) {
				// Entweder lief das Parsen schief, oder
				// die Metrik unterst?tzt den Aufruf nicht
				e.printStackTrace();
				System.exit(1);	// Direkter Abbruch des Programms
			}
		} 
		catch (MalInputFormatException e) {
			e.printStackTrace();
		}
	}

	/**
	 * Kommandozeilenparameter des Designs:
	 * <ul>
	 * 	<li>-m Metrikenname</li>
	 * 	<li>-d Verzeichnisname</li>
	 *  <li>-o Dateiname f?r die Ausgabe (optional)</li>
	 * </ul>
	 * <p>Beispiel: -m SMetric -d OnePlusOnePG_FonsecaF1_1089582482343</p>
	 */
	public static void main(String[] args) {
		Metrics_Plotter_SMS_EMOA_pg mp = new Metrics_Plotter_SMS_EMOA_pg(args); 		
	}
}
