/*
 * Copyright (C) 2005  PG447 - University Dortmund
 * 
 * This file is part of NObELTJE.
 * 
 * NObELTJE is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 * 
 * NObELTJE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with NObELTJE; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

 /*
 * Created on 01.07.2004
 *
 */
package org.nobeltje.exceptions;

/**
 * @author $Author: noot $
 * @version $Revision: 726 $
 * $Date: 2005-02-02 00:50:20 +0100 (Mi, 02 Feb 2005) $
 *
 * Wird geworfen, wenn das binaere Zahlformat nicht korrekt ist (z.B. zu wenige oder zu viele Bits,
 * unerwartete Zahlen- oder Datentypen, ...)
 * 
 */
public class BinaryStringFormatException extends Exception
{

	/**
	 * 
	 */
	public BinaryStringFormatException()
	{
		super();
	}

	/**
	 * @param arg0
	 */
	public BinaryStringFormatException(String arg0)
	{
		super(arg0);
	}
	
	/**
	 * @param size : int :  Die erwartete Anzahl an Bits 
	 */
	public BinaryStringFormatException(int size)
	{
		super("Die binaere Zahl ist nicht "+size+" bit gross und/oder\n"
				+"beinhaltet ungueltige Werte!");
	}

	/**
	 * @param arg0
	 */
	public BinaryStringFormatException(Throwable arg0)
	{
		super(arg0);
	}

	/**
	 * @param arg0
	 * @param arg1
	 */
	public BinaryStringFormatException(String arg0, Throwable arg1)
	{
		super(arg0, arg1);
	}

}
