/*
 * Copyright (C) 2005  PG447 - University Dortmund
 * 
 * This file is part of NObELTJE.
 * 
 * NObELTJE is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 * 
 * NObELTJE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with NObELTJE; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

 /*
 * Created on 15.11.2004
 *
 */
package org.nobeltje.metrics;

import java.util.ArrayList;
import java.util.List;

import org.nobeltje.tools.Individual;

/**
 * @author $Author: noot $
 * @version $Revision: 726 $
 * $Date: 2005-02-02 00:50:20 +0100 (Mi, 02 Feb 2005) $
 */
public class DeltaS implements Metric {

	private SMetricFleischer mySMetric = new SMetricFleischer();
	
	/**
	 * 
	 */
	public DeltaS() {
		super();
	}

	/* (non-Javadoc)
	 * @see metrics.Metric#computeMetric(java.util.List)
	 */
	public double computeMetric(List list) throws Exception {
		return 0;
	}

	/* (non-Javadoc)
	 * @see metrics.Metric#computeMetric(java.util.List, java.util.List)
	 */
	public double computeMetric(List list1, List list2) throws Exception {
		return 0;
	}
	
	public double computeMetric(List population, Individual ind, List refPoint) throws Exception {
		
		// berechne Beitrag von Loesung individual
		mySMetric.setDelta(true);
		
		// setze Referenzpunkt
		mySMetric.setReferencePoint(refPoint);
				
		// ueberpruefe Gueltigkeit bzgl. Referenzpunkt
		for (int i=0; i<refPoint.size(); i++) {
			if (((Double)ind.getFitness().get(i)).doubleValue() > ((Double)refPoint.get(i)).doubleValue()){
			    //DEBUG
			    //System.out.println("Bin in der if Schleife");
				return 0.0;
			}
		}
		
		// erstelle Kopie von solutions damit solutions unveraendert bleibt
		List solutionSorted = new ArrayList();
		int indexInd = population.indexOf(ind);
	    //System.out.println("indexInd "+indexInd);
		
		for (int i=0; i< population.size(); i++)  {
			// fuege ind nicht hinzu
		    //System.out.println("i " +i);
			if ( i != indexInd ) {
				solutionSorted.add( ((Individual)population.get(i)).getFitness());
				//System.out.println("hier solutionSorted"+ solutionSorted.get(i).toString());
			}
		}


		// setze ind ans Ende der Liste damit es zuerst bearbeitet wird
		//System.out.println(ind.getFitness().toString());
		solutionSorted.add(ind.getFitness());
		//System.out.println(solutionSorted.get(population.size()-1).toString());
		

		/*for (int i=0; i< population.size(); i++)  {
			System.out.println("population" + i + ": " + ((Individual)population.get(i)).getFitness().toString());
		}

		for (int i=0; i< solutionSorted.size(); i++)  {
			System.out.println("solutionSorted" + i + ": " + solutionSorted.get(i).toString());
		}
		*/
		// rufe S-Metrik auf
		return mySMetric.computeMetric(solutionSorted);		
	}

	/* (non-Javadoc)
	 * @see metrics.Metric#getParameterCount()
	 */
	public int getParameterCount() {
		return 3;
	}

	public static void main(String[] args) {
	}
}
