/*
 * Copyright (C) 2005  PG447 - University Dortmund
 * 
 * This file is part of NObELTJE.
 * 
 * NObELTJE is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 * 
 * NObELTJE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with NObELTJE; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

 /*
 * Created on 04.07.2004
 *
 */
package org.nobeltje.metrics.test;

import java.util.ArrayList;
import java.util.List;

import junit.framework.TestCase;
import org.nobeltje.metrics.SMetricFleischer;
import org.nobeltje.tools.io.FileParser;

/**
 * @author bene
 * @version $Revision: 726 $
 * $Date: 2005-02-02 00:50:20 +0100 (Mi, 02 Feb 2005) $
 *
 */

public class SMetricFleischerTest extends TestCase {
	SMetricFleischer metric = new SMetricFleischer();

	public void testSMetricValues() {

		
		// 2 Kriterien
		List sol1 = new ArrayList(); 
		sol1.add(new Double(1.0));
		sol1.add(new Double(3.0));

		List sol2 = new ArrayList(); 
		sol2.add(new Double(2.0));
		sol2.add(new Double(2.0));

		List sol3 = new ArrayList(); 
		sol3.add(new Double(3.0));
		sol3.add(new Double(1.0));

		List vecList = new ArrayList();
		vecList.add(sol1);
		vecList.add(sol2);
		vecList.add(sol3);

		List refPoint = new ArrayList();
		refPoint.add(new Double(5.0));
		refPoint.add(new Double(5.0));

		try {
			System.out.println(metric.computeMetric(vecList, refPoint));
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		
		// 3 Kriterien
		List sol1dim3 = new ArrayList(); 
		sol1dim3.add(new Double(1.0));
		sol1dim3.add(new Double(3.0));
		sol1dim3.add(new Double(0.0));

		List sol2dim3 = new ArrayList(); 
		sol2dim3.add(new Double(2.0));
		sol2dim3.add(new Double(2.0));
		sol2dim3.add(new Double(0.0));

		List sol3dim3 = new ArrayList(); 
		sol3dim3.add(new Double(3.0));
		sol3dim3.add(new Double(1.0));
		sol3dim3.add(new Double(0.0));

		List vecListdim3 = new ArrayList();
		vecListdim3.add(sol1dim3);
		vecListdim3.add(sol2dim3);
		vecListdim3.add(sol3dim3);

		List refPointdim3 = new ArrayList();
		refPointdim3.add(new Double(5.0));
		refPointdim3.add(new Double(5.0));
		refPointdim3.add(new Double(5.0));

		try {
			System.out.println(metric.computeMetric(vecListdim3, refPointdim3));
		} catch (Exception e) {
			e.printStackTrace();
		}


		// Teste RefPoint
		
		List invalid = new ArrayList(); 
		invalid.add(new Double(6.0));
		invalid.add(new Double(0.0));
		invalid.add(new Double(0.0));

		List vecListdim3RefPoint = new ArrayList();
		vecListdim3RefPoint.addAll(vecListdim3);
		vecListdim3RefPoint.add(invalid);

		try {
			System.out.println(metric.computeMetric(vecListdim3RefPoint, refPointdim3));
		} catch (Exception e) {
			e.printStackTrace();
		}

	}
	
	
	public void testSMetricOrder() {
		//Teste Reihenfolge
		
		// 3 Kriterien
		List sol1dim3 = new ArrayList(); 
		sol1dim3.add(new Double(5.0));
		sol1dim3.add(new Double(1.0));
		sol1dim3.add(new Double(4.0));

		List sol2dim3 = new ArrayList(); 
		sol2dim3.add(new Double(3.0));
		sol2dim3.add(new Double(4.0));
		sol2dim3.add(new Double(3.0));

		List sol3dim3 = new ArrayList(); 
		sol3dim3.add(new Double(6.1));
		sol3dim3.add(new Double(0.0));
		sol3dim3.add(new Double(2.0));

		List sol4dim3 = new ArrayList(); 
		sol4dim3.add(new Double(4.0));
		sol4dim3.add(new Double(2.0));
		sol4dim3.add(new Double(5.0));

		List vecListdim3 = new ArrayList();
		vecListdim3.add(sol1dim3);
		vecListdim3.add(sol2dim3);
		vecListdim3.add(sol3dim3);
		vecListdim3.add(sol4dim3);


		List vecListdim3_2 = new ArrayList();
		vecListdim3_2.add(sol2dim3);
		vecListdim3_2.add(sol4dim3);
		vecListdim3_2.add(sol3dim3);
		vecListdim3_2.add(sol1dim3);

		List refPointdim3 = new ArrayList();
		refPointdim3.add(new Double(8.0));
		refPointdim3.add(new Double(5.2));
		refPointdim3.add(new Double(6.0));

		try {
			System.out.println(metric.computeMetric(vecListdim3, refPointdim3));
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		try {
			System.out.println(metric.computeMetric(vecListdim3_2, refPointdim3));
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public void testSetRefPoint() {

		SMetricFleischer metricRef = new SMetricFleischer();

		List refPointdim3 = new ArrayList();
		refPointdim3.add(new Double(8.0));
		refPointdim3.add(new Double(5.2));
		refPointdim3.add(new Double(6.0));

		// 3 Kriterien
		List sol1dim3 = new ArrayList(); 
		sol1dim3.add(new Double(5.0));
		sol1dim3.add(new Double(1.0));
		sol1dim3.add(new Double(4.0));

		List sol2dim3 = new ArrayList(); 
		sol2dim3.add(new Double(3.0));
		sol2dim3.add(new Double(4.0));
		sol2dim3.add(new Double(3.0));

		List sol3dim3 = new ArrayList(); 
		sol3dim3.add(new Double(6.1));
		sol3dim3.add(new Double(0.0));
		sol3dim3.add(new Double(2.0));

		List sol4dim3 = new ArrayList(); 
		sol4dim3.add(new Double(4.0));
		sol4dim3.add(new Double(2.0));
		sol4dim3.add(new Double(5.0));

		List vecListdim3 = new ArrayList();
		vecListdim3.add(sol1dim3);
		vecListdim3.add(sol2dim3);
		vecListdim3.add(sol3dim3);
		vecListdim3.add(sol4dim3);

		try {
			System.out.println(metric.computeMetric(vecListdim3));
		} catch (Exception e) {
			e.printStackTrace();
		}
				
		metricRef.setReferencePoint(refPointdim3);
		
		assertSame("Falscher RefPoint", metricRef.getReferencePoint(), refPointdim3);
	}
		
	public void testMetricMultiDim() {
		// Test von hochdimensionalen Funktionen fuer den Temperierbohrungs-Simulator
		
		List testList = new ArrayList();
		double sValue = 0.0;
		
		// Werte einlesen
		try {
			FileParser.parseFile("testSMetric.dat", testList);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		// Referenezpunkt setzen
		List refPoint = new ArrayList();
		refPoint.add(new Double(5.0));
		refPoint.add(new Double(3.0));
		refPoint.add(new Double(2.0));
		refPoint.add(new Double(10.0));
		refPoint.add(new Double(25.0));
		refPoint.add(new Double(2.0));

		
		// rufe Metrik auf
		try {
			sValue = metric.computeMetric(testList, refPoint);
		} catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	
		System.out.println("sValue: " + sValue);
	}

}
