/*
 * Copyright (C) 2005  PG447 - University Dortmund
 * 
 * This file is part of NObELTJE.
 * 
 * NObELTJE is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 * 
 * NObELTJE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with NObELTJE; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

 /*
 * Created on Nov 10, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.nobeltje.testfkt;


import java.util.ArrayList;
import java.util.List;

/**
 * @author lickfeld
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Schaffer extends AbstractTestfkt {
    
	public static final int INPUT_PARAMETERS = 1;
	public static final int RETURN_PARAMETERS = 2;
	
	
	
	
	
	
	/**
	 * Eine weitere Testfunktion, liefert eine ArrayList mit den Funktionsweten von f1 und f2 zurueck.
	 * @return ArrayList Werte f1(x,) und f2(x)
	 * @param List input Liste mit den  Funktionswerten f?r x 
	 *
	 */
	public List execute (List input) throws Exception {
		if (input.get(0).getClass().equals(Double.class)) {
			double x = ((Double) input.get(0)).doubleValue();
			List results = new ArrayList();
			double d = Math.pow((x-5),2);
			if (x <-5 || x>10){
				results.add(new Double(x));
				results.add(new Double(x));
				results=setPenalty(results);
			    //results.add(new Double(1000000));
			}
			else
			if (x<=1){
				results.add(new Double(-x));
				results.add(new Double (d));
			}
			else
			if (x>1 && x<=3){
				results.add(new Double(-2+x)); 
				results.add(new Double(d));
			}
			else
				if (x>3 && x<=4){
					results.add(new Double(4-x));
					results.add(new Double(d));
				}
				else
					if (x>4){
						results.add(new Double(-4+x));
						results.add(new Double(d));
					}
		
			return results;
		} else {
		throw new Exception ("Kein Double Objekt als Parameter erhalten!");
		}
	}

	
	public void writeParetoPoints(int n, String filename) throws Exception {
		// Da wir nicht wissen, wie die "wahre" Pareto-Front analytisch angegeben 
		// werden kann, wird diese Methode (zunaechst?) nicht implementiert. 
	}	

	
	public List getOptimalBounds() {
		List bounds = new ArrayList();
		
		// ein Vernuenftiger Wertebereich fuer "gute" Individuen dieser 
		// Funktion liegt z.B. zwischen (-5|10), da x  nur dort definiert ist
		
		bounds.add(new Double(-5));	
		bounds.add(new Double(10));
		
		
		
		return (bounds);
		
	}
	public List getBounds() {
		return getOptimalBounds();
		}
	
	public List getStartPoint() {
		List point = new ArrayList();
		
		// Hier wird ein Punkt ausgegeben, der nicht sehr weit der Pareto-Optimalen Loesungen liegt.
		point.add(new Double(0.5));
		
		
		return(point);
	}

	
	public int getDimension() {
		return(INPUT_PARAMETERS);		// Dimension ist 1
	}

	
	public int getNumberOfObjectives() {
		return (RETURN_PARAMETERS);
	}

	/**
	 * 
	 * toString-Methode, wird hier benutzt, um eine Testfunktions-Beschreibung zu uebergeben
	 * 
	 * @see tools.io.Help
	 */
	public String toString() {
		String description;

		description = "Klasse Schaffer, Paket testfkt \n\n";
		description += "Beschreibung :\n\n";
		description += "Zweikriterielle Testfunktion mit einer Variablen\n";
		description += "Eingabe: Variablenwerte, als Double-Objekte in einer ArrayList\n";
		description += "Ausgabe: eine ArrayList mit zwei Double-Objekten, naemlich den Funktionswerten f1 und f2\n";
		description += "\n";
		description += "Funktion:\n";
		description += "minimiere f1=-x wenn x<=1, sonst f1=-2+x wenn 1<=x<=3, sonst f1=4-x wenn 3<x<=4, sonst f1=-4+x wenn x>4  und minimiere \n f2=(x-5)^2\n";
		description += "Die Pareto-Optimalen Punkte liegen zwischen -5<=x<=10, der Definitionsbereich ist analog.\n";
	
		return (description);
	}
	/**
	 * Methode zum Beenden. Wichtig ist diese Methode gerade fuer das Temperierbohrungsproblem, 
	 * da dieses die einzige Moeglichkeit ist, die Verbindung zum Server zu disconnecten.
	 *
	 */
	public void finalize(){
	}
	
}
