/*
 * Copyright (C) 2005  PG447 - University Dortmund
 * 
 * This file is part of NObELTJE.
 * 
 * NObELTJE is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 * 
 * NObELTJE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with NObELTJE; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

 /*
 * Created on Nov 29, 2004
 *
 */
package org.nobeltje.testfkt;

import java.util.ArrayList;
import java.util.List;

import org.nobeltje.exceptions.MalInputFormatException;

/**
 * @author $Author: noot $
 * @version $Revision: 726 $
 * $Date: 2005-02-02 00:50:20 +0100 (Mi, 02 Feb 2005) $
 */
public class ZDT_12 extends AbstractTestfkt {

	public static final int INPUT_PARAMETERS = 30;
	public static final int RETURN_PARAMETERS = 12;

	/* (non-Javadoc)
	 * @see testfkt.TestFunctions#execute(java.util.List)
	 */
	public List execute(List input) throws Exception {
		if (input.get(0).getClass().equals(Double.class)) {
			if (input.size() == this.getDimension()) {
				List results = new ArrayList();
				
				ZDT1 zdt1Dummy = new ZDT1();
				List zdt1Values = zdt1Dummy.execute(input);
				Double f1 = (Double)zdt1Values.get(0); 
				Double f2 = (Double)zdt1Values.get(1); 
				
				ZDT2 zdt2Dummy = new ZDT2();
				List zdt2Values = zdt2Dummy.execute(input);
				Double f3 = (Double)zdt2Values.get(0); 
				Double f4 = (Double)zdt2Values.get(1); 
				
				ZDT3 zdt3Dummy = new ZDT3();
				List zdt3Values = zdt3Dummy.execute(input);
				Double f5 = (Double)zdt3Values.get(0); 
				Double f6 = (Double)zdt3Values.get(1); 
				
				results.add(f1);
				results.add(f2);
				results.add(f3);
				results.add(f4);
				results.add(f5);
				results.add(f6);
				results.add(f1);
				results.add(f2);
				results.add(f3);
				results.add(f4);
				results.add(f5);
				results.add(f6);
	
				return results;
			} else
				throw new MalInputFormatException("Anzahl Variablen ungleich 30.");
		} else
			throw new Exception ("Kein Double Objekt als Parameter erhalten!");
	}

	/* (non-Javadoc)
	 * @see testfkt.TestFunctions#writeParetoPoints(int, java.lang.String)
	 */
	public void writeParetoPoints(int n, String filename) throws Exception {
		// nicht implementiert
	}

	/* (non-Javadoc)
	 * @see testfkt.TestFunctions#getOptimalBounds()
	 */
	public List getOptimalBounds() {
		List bounds = new ArrayList();
		
		for (int i=0; i<getDimension(); i++) {
			bounds.add(new Double(0));
			bounds.add(new Double(1));
		}
		return (bounds);
	}

	/* (non-Javadoc)
	 * @see testfkt.TestFunctions#getStartPoint()
	 */
	public List getStartPoint() {
		List point = new ArrayList();
		
		for (int i=0; i<getDimension(); i++) {
			point.add(new Double(0.5));
		}
		return (point);
	}

	/* (non-Javadoc)
	 * @see testfkt.TestFunctions#getDimension()
	 */
	public int getDimension() {
		return INPUT_PARAMETERS;
	}

	/* (non-Javadoc)
	 * @see testfkt.TestFunctions#getNumberOfObjectives()
	 */
	public int getNumberOfObjectives() {
		return RETURN_PARAMETERS;
	}

}
