/*
 * Copyright (C) 2005  PG447 - University Dortmund
 * 
 * This file is part of NObELTJE.
 * 
 * NObELTJE is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 * 
 * NObELTJE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with NObELTJE; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

 /*
 * Created on Jul 1, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package org.nobeltje.tools;

import java.util.ArrayList;


// 
/**
 * Die Klasse Leaf erbt von der Klasse Vertex und stellt ein Blatt des HyperCubeTree da.
 * Sie representiert die Hypercubes, die von der Klasse HyperCubeTree berechnet werden, und speichert die  
 * Indizes der Vektoren und ihre Anzahl 
 *
 *  @author janas
 * @version $Revision: 726 $
 * $Date: 2005-02-02 00:50:20 +0100 (Mi, 02 Feb 2005) $
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class Leaf extends Vertex implements Comparable
 {
 	/**
 	 * Anzahl der Vektoren im HyperKube
 	 */
	private int quantity = 0; 
	       
	/**
	 * die Liste enthaelt die Indizes der Vektors ,die sich in diesem Hyperkube befinden.
	 * In die Liste werden Objekte des Typs Integer eingefuegt
	 */                
	private ArrayList indexList = new ArrayList(); 
	
	/**
	 * Konstruktor: Erzeugt ein Blatt mit quantity = 1 und fuegt den Integer in in die Indexliste ein 
	 * @param in Index des Vektors der beim initialiesieren des Cubes eingefuegt wird 
	 */
	public Leaf( Integer in)
	{
		super( 1);
		quantity = 1;
		indexList= new ArrayList();
		indexList.add(in);
	}
	/**
	 * die Methode vergleicht das Objekt mit dem uebergebenen Objekt b bezueglich des Attributs quantity
	 * sie gibt -1 zurueck wenn this.quantity kleiner als b.quantity , 0 bei Gleichheit und +1 wenn das uebergebene objekt groosser ist 
	 * @param b Objekt mit dem vergliechen werden soll
	 * @return int -1 ,0,+1 je nachdem ob das Objekt kleiner, gleich oder groosser als das uebergebene Objekt ist
	 */
	public int compareTo(Object b)
	{ 
		Leaf o=(Leaf)b;
		if(this.quantity <o.quantity)
			return (-1) ;
		if(this.quantity ==o.quantity)
			return 0 ;
		else
			return 1 ;
	}
	/**
	 * setzt die Anzahl der Vektoren, die sich in diesem Hypercube befinden 
	 * @param i Anzahl der Vektoren
	 */
	public void setQuantity(int i)
	{
		quantity =i;
	}
	/**
	 * liefert die Anzahl der Vektoren in diesem Hypercube
	 * @return quantity Anzahl der Vektoren
	 */
	public int getQuantity()
	{
		return quantity ;
	}
	/**
	 * setzt die IndexList des Objekts
	 * @param list uebergebene Liste
	 */
	public void setIndexList(ArrayList list)
	{
		indexList = list ;
	}
	/**
	 * gibt die Indexliste zurueck
	 * @return Indexliste
	 */
	public ArrayList getIndexList()
	{
		return indexList ;
	}
	/**
	 * Fuegt den uebergebenen Integer in die Indexliste ein
	 * @param i Index des Vektors
	 */
	public void addInteger(Integer i)
	{
		indexList.add(i);
	}
	
	/**
	 * Liefert der Index zurueck, der ind der Indexliste an Position i gespeichert ist
	 * @param i Position in der IndexListe
	 * @return  Index, der sich in der  Liste an Position i befindet. 
	 */
	public Integer getInteger(int i){
		return (Integer)indexList.get(i);
	}
}