/*
 * Copyright (C) 2005  PG447 - University Dortmund
 * 
 * This file is part of NObELTJE.
 * 
 * NObELTJE is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 * 
 * NObELTJE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with NObELTJE; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

 /*
 * Created on Jul 1, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package org.nobeltje.tools;

/**
 * Die Klasse Vertex stellt einen Knoten da, der fuer die implementierung der Klasse HyperCubeTree gebraucht wird.
 * 
 * @author janas
 *  @version $Revision: 726 $
 * $Date: 2005-02-02 00:50:20 +0100 (Mi, 02 Feb 2005) $
 *
 */

public class Vertex {
	
	protected Vertex [] child; 
	
	/**
	 * Konstruktor eines Knotens, dem eine Anzahl von Kinder uebergeben wird,  
	 * die die Rasterung des Raumes representieren.
	 * @param divisions Anzahl der Kinder des Knotens
	 */
	
	public Vertex( int  divisions) 
	{ 
		child = new	Vertex[divisions];
	}
	
	/**
	 * Methode, die ein Kind setzt
	 * @param child , Array von Knoten
	 */
	public void setChild(Vertex [] child)
	{
		this.child = child ;
	}
	
	/**
	 * gibt die Kinder in einem Array zurueck
	 * @return Array der  Kinder 
	 */
	public Vertex [] getChild()
	{
		return child;
	}
	
	/**
	 * Falls der index zulaessig ist, wird der uebergebene Knoten ver in das Array der Kinder an Position index  gesetzt und true 
	 * zurueckgegeben, ansonsten false
	 * @param index Index eines Kindes
	 * @param ver ein Knoten 
	 * @return true, wenn ein solches Kind existiert, also der Index korrekt ist, sonst false.
	 */
	public boolean setChild(int index , Vertex ver)
	{
		if (index > -1 && index < child.length )
		{
		    child[index] = ver ;
		    return true ;
		}
		else 
			return false ;
	}
}