/*
 * Copyright (C) 2005  PG447 - University Dortmund
 * 
 * This file is part of NObELTJE.
 * 
 * NObELTJE is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 * 
 * NObELTJE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with NObELTJE; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

 /*
 * Created on 01.12.2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package org.nobeltje.tools.io;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FilenameFilter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.ListIterator;
import java.util.StringTokenizer;

import org.nobeltje.tools.Individual;
import org.nobeltje.analysis.FitnessFilter;
import org.nobeltje.analysis.IndividualFilter;
import org.nobeltje.exceptions.MalInputFormatException;
import org.nobeltje.exceptions.NoIndividualException;

/**
 * @author kay
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class FilterAndDelete {

	/**
	 * 
	 */
	private File inputDir;
	private boolean isDeleteInvalidIndividualsCall = false;
	private boolean isCommaKillerCall =false;
	private boolean isSelectCall = false;
	private String convertDirection = "";
	private boolean isConvertCall = false;
	private boolean undo = false;
	private boolean scale = false;
	String selection = "";
	
	public FilterAndDelete(String []args) {
		
		super();
		PropertiesPG prop = new PropertiesPG();
		try {
			//Das Verzeichnis kommt aus der Kommandozeile
			prop = (PropertiesPG)ArgsInputBeautifier.beautify(args);
		} catch (MalInputFormatException e) {
			e.printStackTrace();
		}
		inputDir = new File (prop.getStringProperty("d","",true));
		
		isDeleteInvalidIndividualsCall = (prop.getStringProperty("del_Invalid","false",false)).compareTo("true")==0;
		isCommaKillerCall = (prop.getStringProperty("del_Comma","false",false)).compareTo("true")==0;
		convertDirection = prop.getStringProperty("convert","",false);
		isConvertCall = (convertDirection.compareTo("")!=0);
		selection = (prop.getStringProperty("select","",false));
		isSelectCall = (selection.compareTo("")!=0);
		undo = (prop.getStringProperty("undo","false",false)).compareTo("true")==0;
		scale = (prop.getStringProperty("scale","false",false)).compareTo("true")==0;
		
		File [] inRes = inputDir.listFiles(new FitnessFilter());
		File [] inIn = inputDir.listFiles(new IndividualFilter());
		if (inRes == null){
			inRes = new File[0];
		}
		System.out.println("Anzahl der Dateien: "+inRes.length);
		System.out.println("delComma: "+isCommaKillerCall);
		System.out.println("delInvalid: "+isDeleteInvalidIndividualsCall);
		System.out.println("Selection: "+selection);
		System.out.println("Convert: "+isConvertCall);
		System.out.println("Undo: "+undo);
		for (int i=0;i<inRes.length;i++){
			if (undo){
				undo(inputDir);
			}
			if (scale){
				try {
					ArrayList res = new ArrayList();
					FileParser.parseFile(inRes[i].getAbsolutePath(),res);
					deleteToBigRows(res,inRes[i].getAbsolutePath());
				} catch (Exception e1) {
					e1.printStackTrace();
				}
			}
			if (isCommaKillerCall){
				deleteComma(inRes[i]);
				deleteComma(inIn[i]);
			}
			if (isConvertCall){
				boolean convertPtToComma = (convertDirection.compareTo("point")==0);
				convert(inRes[i],convertPtToComma);
				convert(inIn[i],convertPtToComma);
			}
			if (isDeleteInvalidIndividualsCall){
				try {
					ArrayList res = new ArrayList();
					FileParser.parseFile(inRes[i].getAbsolutePath(),res);
					if (!res.isEmpty()){
						deleteInvalidRows(res,inRes[i].getAbsolutePath());
					}
//					deleteInvalidRows(res,inRes[i].getAbsolutePath());
				} catch (Exception e1) {
					e1.printStackTrace();
				}
			}
			if (isSelectCall){
				ArrayList columnsToDelete = new ArrayList();
				
				for (StringTokenizer st = new StringTokenizer(selection,",");st.hasMoreElements();){
					columnsToDelete.add(new Integer(st.nextToken()));
				}
				selectColumns(columnsToDelete,inRes[i]);
			}
			//			System.out.println("");
		}
	}
	
	public void deleteComma (File data){
		try {
			FileInputStream in = new FileInputStream(data);
			byte[] buf = new byte[4096];
			ArrayList fileAsBytes = new ArrayList();
			int len;
			while ((len = in.read(buf)) > 0) {
				for (int i=0; i<len;i++){
					fileAsBytes.add(new Byte(buf[i]));
				}
			}
			in.close();
			if (fileAsBytes.contains(new Byte((byte)','))){
				data.delete();
				int k;
				while ((k=fileAsBytes.indexOf(new Byte((byte)',')))>=0){
					System.out.println("Komma gefunden!");
					fileAsBytes.remove(k);
				}
				FileOutputStream out = new FileOutputStream(data.getAbsolutePath());
				for (int i = 0;i<fileAsBytes.size();i++){
					byte value = ((Byte)fileAsBytes.get(i)).byteValue();
//					System.out.println(value);
					out.write(value);
				}
				out.close();
				
			}
			
		} catch (IOException e) {
			System.err.println(e.toString());
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public void convert (File data,boolean pt2Comma){
		try {
			FileInputStream in = new FileInputStream(data);
			byte[] buf = new byte[4096];
			ArrayList fileAsBytes = new ArrayList();
			int len;
			while ((len = in.read(buf)) > 0) {
				for (int i=0; i<len;i++){
					fileAsBytes.add(new Byte(buf[i]));
				}
			}
			in.close();
			if ((pt2Comma)&&(fileAsBytes.contains(new Byte((byte)'.')))){
				data.delete();
				int k;
				while ((k=fileAsBytes.indexOf(new Byte((byte)'.')))>=0){
//					System.out.println("Punkt gefunden an Stelle "+k);
					fileAsBytes.remove(k);
					fileAsBytes.add(k,new Byte((byte)','));
				}
				FileOutputStream out = new FileOutputStream(data.getAbsolutePath());
				for (int i = 0;i<fileAsBytes.size();i++){
					byte value = ((Byte)fileAsBytes.get(i)).byteValue();
//					System.out.println(value);
					out.write(value);
				}
				out.close();
				
			} else {
				if ((!pt2Comma)&&(fileAsBytes.contains(new Byte((byte)',')))){
					data.delete();
					int k;
					while ((k=fileAsBytes.indexOf(new Byte((byte)',')))>=0){
//						System.out.println("Punkt gefunden an Stelle "+k);
						fileAsBytes.remove(k);
						fileAsBytes.add(k,new Byte((byte)'.'));
					}
					FileOutputStream out = new FileOutputStream(data.getAbsolutePath());
					for (int i = 0;i<fileAsBytes.size();i++){
						byte value = ((Byte)fileAsBytes.get(i)).byteValue();
//						System.out.println(value);
						out.write(value);
					}
					out.close();
					
				}
			}
			
		} catch (IOException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public void deleteInvalidRows (ArrayList data, String filename){
		ArrayList result = new ArrayList();
		ArrayList rowsToKill = new ArrayList();
		for (int i = 0;i< data.size();i++){
			ArrayList fitnessVector = new ArrayList();
			fitnessVector = (ArrayList)data.get(i);
			for (int j=0; j< fitnessVector.size();j++){
				double currentFitness = ((Double)fitnessVector.get(j)).doubleValue();
//				System.out.println(currentFitness);
				if (rowsToKill.contains(new Integer(i))){
					break;
				}
				switch (j){
					case 0: {break;}
					case 1: {break;}
					case 2:	{if (currentFitness>1.0)rowsToKill.add(new Integer(i));break;}
					case 3: {break;}
					case 4: {break;}
					case 5: {break;}
					case 6: {break;}
					case 7: {if (currentFitness>0.0)rowsToKill.add(new Integer(i));break;}
					case 8:	{if (currentFitness>0.0)rowsToKill.add(new Integer(i));break;}
					case 9: {if (currentFitness>0.0)rowsToKill.add(new Integer(i));break;}
					case 10: {if (currentFitness>0.0)rowsToKill.add(new Integer(i));break;}
					case 11: {if (currentFitness>0.0)rowsToKill.add(new Integer(i));break;}
				}
			}
			if (rowsToKill.size()==1){
				System.out.println(filename+": "+i);
			}
		}
		if (!rowsToKill.isEmpty()){
//			System.out.println("zugehrige .in:"+filename.substring(0,filename.length()-3)+"in");
//			File individualFile = new File (filename.substring(0,filename.length()-3));
			ArrayList individualsObj = new ArrayList();
			Collections.sort(rowsToKill);
			Collections.reverse(rowsToKill);
			try {
				FileParser.parseFile(filename.substring(0,filename.length()-3)+"in",individualsObj);
				for (Iterator iter= rowsToKill.iterator(); iter.hasNext();){
					int row = ((Integer)iter.next()).intValue();
					individualsObj.remove(row);
					data.remove(row);
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
			
			for (int i=0;i<data.size();i++){
				Individual indi = new Individual();
				indi.setObjectVariables((ArrayList)individualsObj.get(i));
				indi.setFitness((ArrayList)data.get(i));
				result.add(indi);
			}
			try {
				AlgoOutput.writeObjectVariables(result,filename.substring(0,filename.length()-9),false);
				AlgoOutput.writeFitness(result,filename.substring(0,filename.length()-9),false);
			} catch (NoIndividualException e1) {
				e1.printStackTrace();
			}
		}
	}
	
	public void deleteToBigRows (ArrayList data, String filename){
		ArrayList result = new ArrayList();
		ArrayList rowsToKill = new ArrayList();
		for (int i = 0;i< data.size();i++){
			ArrayList fitnessVector = new ArrayList();
			fitnessVector = (ArrayList)data.get(i);
			for (int j=0; j< fitnessVector.size();j++){
				double currentFitness = ((Double)fitnessVector.get(j)).doubleValue();
//				System.out.println(currentFitness);
				if (rowsToKill.contains(new Integer(i))){
					break;
				}
				switch (j){
					case 0: {if (currentFitness>75.0)rowsToKill.add(new Integer(i));break;}
					case 1: {if (currentFitness>25.0)rowsToKill.add(new Integer(i));break;}
					case 2:	{if (currentFitness>1000.0)rowsToKill.add(new Integer(i));break;}
					case 3: {if (currentFitness>1000.0)rowsToKill.add(new Integer(i));break;}
					case 4: {if (currentFitness>5.0)rowsToKill.add(new Integer(i));break;}
				}
			}
			if (rowsToKill.size()==1){
				System.out.println(filename+": "+i);
			}
		}
		if (!rowsToKill.isEmpty()){
//			System.out.println("zugehrige .in:"+filename.substring(0,filename.length()-3)+"in");
//			File individualFile = new File (filename.substring(0,filename.length()-3));
			ArrayList individualsObj = new ArrayList();
			try {
				FileParser.parseFile(filename.substring(0,filename.length()-3)+"in",individualsObj);
				for (Iterator iter= rowsToKill.iterator(); iter.hasNext();){
					int row = ((Integer)iter.next()).intValue();
					individualsObj.remove(row);
					data.remove(row);
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
			
			for (int i=0;i<data.size();i++){
				Individual indi = new Individual();
				indi.setObjectVariables((ArrayList)individualsObj.get(i));
				indi.setFitness((ArrayList)data.get(i));
				result.add(indi);
			}
			try {
				AlgoOutput.writeObjectVariables(result,filename.substring(0,filename.length()-9),false);
				AlgoOutput.writeFitness(result,filename.substring(0,filename.length()-9),false);
			} catch (NoIndividualException e1) {
				e1.printStackTrace();
			}
		}
	}
	
	public void selectColumns (ArrayList columns, File fileToFilter){
		try {
			Collections.sort(columns);
			Collections.reverse(columns);
			System.out.println("Spalten: "+columns);
			ArrayList rowsAsList = new ArrayList(); 
			FileParser.parseFile(fileToFilter.getAbsolutePath(),rowsAsList);
			for (ListIterator iterRows = rowsAsList.listIterator();iterRows.hasNext();){
				ArrayList row = (ArrayList)iterRows.next();
				for (Iterator iterColumns = columns.iterator();iterColumns.hasNext();){
					row.remove(((Integer)iterColumns.next()).intValue()-1);
				}
			}
			String oldFileName = fileToFilter.getAbsolutePath();
			fileToFilter.renameTo(new File(oldFileName+".old"));
			ArrayList result = new ArrayList();
			for (int i=0;i<rowsAsList.size();i++){
				Individual indi = new Individual();
				indi.setObjectVariables(new ArrayList());
				indi.setFitness((ArrayList)rowsAsList.get(i));
				result.add(indi);
			}
			try {
				AlgoOutput.writeFitness(result,oldFileName.substring(0,oldFileName.length()-9),false);
			} catch (NoIndividualException e1) {
				e1.printStackTrace();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		
	}
	
	public void undo (File inDir){
		File [] oldData = inDir.listFiles(new FilenameFilter(){
			public boolean accept (File dir, String name) {
				return (name.endsWith(".old"))?true:false;
			}
		});
		for (int i=0; i<oldData.length;i++){
			String newFileName = oldData[i].getAbsolutePath().substring(0,oldData[i].getAbsolutePath().length()-4);
			System.out.println(newFileName);
			oldData[i].renameTo(new File(newFileName));
		}
	}
	
	
	public static void main (String[]args){
		FilterAndDelete far = new FilterAndDelete(args);
	}

}
