/*
 * Copyright (C) 2005  PG447 - University Dortmund
 * 
 * This file is part of NObELTJE.
 * 
 * NObELTJE is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 * 
 * NObELTJE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with NObELTJE; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

 /*
 * Created on 28.06.2004
 */
package org.nobeltje.tools.io;



/**
 * Diese Klasse ruft nur die Methode toString() der angegebenen Klasse auf und gibt dessen Rueckgabe auf der Konsole aus.
 *
 * Dazu muss die Klasse mit Paket angegeben werden, also mit Punkt-Trennung zwischen Paketen,
 * z.B.: java tools/io/Help algo.MueRhoLES
 * 
 * @author $Author: noot $
 * @version $Revision: 726 $
 * $Date: 2005-02-02 00:50:20 +0100 (Mi, 02 Feb 2005) $
 */

public class Help {
    
    /**
     * Leerer Konstruktor, der nur den Konstruktor der Superklasse aufruft.
     */
    public Help() {
        super();
    }

    /**
     * Main-Methode, die die toString()-Methode der angegebenen Klasse startet und ausgibt. 
     * 
	 * Dazu muss die Klasse mit Paket angegeben werden, also mit Punkt-Trennung zwischen Paketen,
	 * z.B.: java tools/io/Help algo.MueRhoLES
	 * 
	 * @param args String[] - String der Kommandozeilenparameter
     */
    public static void main(String[] args) {

        try {
        	
           /* Name der Zielklasse holen */	
        	String classnameTarget = args[0];  // Name der Klasse, fuer die Infos ausgegeben werden sollen
        	
	       /* Kasse dynamisch einbinden */
			// Klasse anhand des Namens anbinden
			Class testClass = Class.forName(classnameTarget);
			// Objekt vom Typ Objekt aus Klasse erzeugen  
			Object testObject = testClass.newInstance();  
			
			System.out.println(testObject.toString());
			
        }
		/* Fehler bei nicht gefundener Testklasse ausgeben und Abbrechen */
		catch (ClassNotFoundException e){
			System.out.println("\nFEHLER: Angegebene Klasse konnte nicht gefunden werden.\n\n");
			e.printStackTrace();
			System.exit(1);	// Direkter Abbruch des Programms
		}
		/* Fehler bei unzulaessiger Testklasse ausgeben und Abbrechen */
		catch (ClassCastException e){
			 System.out.println("\n FEHLER: Angegebene Klasse ist nicht zulaessig (Cast-Fehler). \n\n");
			 e.printStackTrace();
			 System.exit(1);	// Direkter Abbruch des Programms
		} 
		/* Fehler ausgeben und Abbrechen, wenn Testklasse nicht instanziiert werden kann */
		catch (InstantiationException e2) {
			 System.out.println("\n FEHLER: Angegebene Klasse kann nicht instanziiert werden. \n\n");
	 		 e2.printStackTrace();
			 System.exit(1);	// Direkter Abbruch des Programms
		}
		/* Sonstige Fehler.. */
		catch (IllegalAccessException e2) {
			 e2.printStackTrace();
			 System.exit(1);	// Direkter Abbruch des Programms
		}
		catch (Exception e) {
			 e.printStackTrace();
			 System.exit(1);	// Direkter Abbruch des Programms
		}

    }
}
