/*
 * Copyright (C) 2005  PG447 - University Dortmund
 * 
 * This file is part of NObELTJE.
 * 
 * NObELTJE is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 * 
 * NObELTJE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with NObELTJE; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

 /*
 * Created on Dec 6, 2004
 * Ralf Kosse
 *
 */
package org.nobeltje.tools.io;


import java.io.File;
import java.util.ArrayList;

/**
 * @author $Author: noot $
 * @version $Revision: 726 $
 * $Date: 2005-02-02 00:50:20 +0100 (Mi, 02 Feb 2005) $
 */



public class SortFile{


	// Leerer Konstruktor
	public SortFile(){
		
	}

	/*
	 *
	 * @author kosse
	 *
	 * To change the template for this generated type comment go to
	 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
	 * 
	 * Sortiert ein Array von Dateien (fileArray) nach den Werten des per "sortingParameter" angegebenen 
	 * Parameternamens . Der Parameter(z.B. g=100, g=200, g=300, ...), der im Dateinamen jeweils vorkommen muss (!), 
	 * wird im Dateinamen gefolgt von seinem Wert. Diese Werte beeinflussen nun die Sortierung. Kommen 
	 * mehrere Dateinamen mit denselben Werten dieses Parameters vor, so wird deren Sortierung 
	 * untereinander nicht beeinflusst.
	 */

	
	public static File[] sortFileList(File fileArray[], String sortingParameter){
		
		// Zum speichern des jew. Parameter-Wertes
		String paramValue;
		
		// ArrayListe, die Objekte des Typs FileParamTwin (Kombination aus File und String, der den Parameterwert der Datei enthaelt) enthaelt 
		ArrayList twinList = new ArrayList(fileArray.length); 
		
		
		// Hier wird eine ArrayList mit den FileParamTwin-Objekten gef?llt
		for (int i=0; i<fileArray.length; i++){
			// Ein File-ParameterWert-ZTwin erstellen und zwar mit der Datei aus der i-ten Position von fileArray und 
			// dessen Wert fuer den Parameternamen sortingParameter
			FileParamTwin twin = new FileParamTwin(fileArray[i], (extractParameterValues(sortingParameter, fileArray, i)));
			twinList.add(twin);	
		}

		// Hier wird die Liste sortiert 
		bubbleSortList(twinList);
		
		// ArrayList wieder zurueck in das File-Array speichern
		for (int i=0; i<fileArray.length; i++){
			fileArray[i] = (File)((FileParamTwin)twinList.get(i)).getFile();
		}		
		
		return fileArray;
	}
	

	/*
	 * Sortiert eine ArrayList mit FileParamTwin-Objekten nach deren ParamValue-Strings gemaess des 
	 * BubbleSort-Algorithmus'  
	 * 
	*/
	
	
	private static ArrayList bubbleSortList(ArrayList twinList){
		
		// wurde eine Vertauschung vorgenommen?
		boolean toggled=true;
		
		// Solange vertauscht werden muss...
		while (toggled){

			toggled = false;
			
			// die gesamte Dateiliste...
			for (int j=0; j<twinList.size()-1; j++){
				
				// Die Parameter-Werte aus den Twins lesen
				String stringValue1 = ((FileParamTwin)twinList.get(j)).getParamValue();
				String stringValue2 =  ((FileParamTwin)twinList.get(j+1)).getParamValue();
				
				Double value1=null;
				Double value2=null;
				
				try{
					value1 = new Double(stringValue1);
					value2 = new Double(stringValue2);
				}

				catch(Exception e){
					System.out.println("Kein double-Wert!");
					e.printStackTrace();
					System.exit(1);					
				}

				
				//Parameterwerte vergleichen: Ist value 1 lexikographisch groesser als value2 ? -> vertauschen!
				if (value1.doubleValue()  > value2.doubleValue()){
					// 2. twin zwischenspeichern 
					FileParamTwin dummy = (FileParamTwin)twinList.get(j+1);
					// twin von Position j an j+1 speichern
					twinList.set(j+1, (FileParamTwin)twinList.get(j));
					twinList.set(j, dummy);
					toggled = true; // Ja, wir haben vertauscht!
				}
			}
		}
		
		return twinList;
	}


	
	/*
	 * Sortiert eine ArrayList mit FileParamTwin-Objekten nach deren ParamValue-Strings gemaess des 
	 * BubbleSort-Algorithmus'  
	 * 
	 *
	
DIESE VERSION VERGLEICHT STRINGS (bzw. auch Zahlen, sortiert diese aber wie Strings, also 50 vor 100 vor 2000 vor 21 vor 30 vor 5000 vor 620, ...):	
	
	
	private static ArrayList bubbleSortList(ArrayList twinList){
		
		// wurde eine Vertauschung vorgenommen?
		boolean toggled=true;
		
		// Solange vertauscht werden muss...
		while (toggled){

			toggled = false;
			
			// die gesamte Dateiliste...
			for (int j=0; j<twinList.size()-1; j++){
				
				// Die Parameter-Werte aus den Twins lesen
				String value1 = ((FileParamTwin)twinList.get(j)).getParamValue();
				String value2 =  ((FileParamTwin)twinList.get(j+1)).getParamValue();
				
				//Parameterwerte vergleichen: Ist value 1 lexikographisch groesser als value2 ? -> vertauschen!
				if (value1.compareTo(value2)  > 0){
					// 2. twin zwischenspeichern 
					FileParamTwin dummy = (FileParamTwin)twinList.get(j+1);
					// twin von Position j an j+1 speichern
					twinList.set(j+1, (FileParamTwin)twinList.get(j));
					twinList.set(j, dummy);
					toggled = true; // Ja, wir haben vertauscht!
				}
			}
		}
		
		return twinList;
	}
	
	*/
	
	/*
	 * Extrahiert den Wert des per paramName uebergebenden Parameters aus der i-ten
	 * Datei des fileArray.
	 * Zurueckgegeben wird ein String, in dem der Parameterwert steht
	 */
	 private static String extractParameterValues(String paramName, File fileArray[], int i){

		// String, um Dateinamen zu speichern & zu behandeln
		String filename;
				
		// Die zugehoerigen StringBuffer
		StringBuffer parambuf = new StringBuffer();
				
		filename = fileArray[i].getName();

		// Position der beiden Parameter im Dateinamen lokalisieren
		int j = filename.indexOf(paramName);						
					
		// um die Laenge des Parameter-Namens und um das "="-Zeichen verschieben	
		j = j + paramName.length()+1;
				
		// Den Parameter-Wert extrahieren (beginnt hinter dem '=' hinter dem Parameternamen und endet mit einem '_' oder einem ".best")
		for (int m = 0; (filename.charAt(j+m)!='_')&&(!filename.substring(j+m ,  j+m+5).equals(".best"))&&(!filename.substring(j+m ,  j+m+4).equals(".gif"))&&(!filename.substring(j+m ,  j+m+4).equals(".png"))&&(!filename.substring(j+m ,  j+m+4).equals(".jpg")); m++){
			parambuf.append(filename.charAt(j+m));
		}

		// Strings kopieren
		return parambuf.toString();

	 }


}


