/*
 * Copyright (C) 2005  PG447 - University Dortmund
 * 
 * This file is part of NObELTJE.
 * 
 * NObELTJE is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 * 
 * NObELTJE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with NObELTJE; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

 /*
 * Created on Jul 12, 2004
 *
 */
package org.nobeltje.tools.io.test;

import java.util.ArrayList;

import junit.framework.TestCase;
import org.nobeltje.tools.io.ListOperation;

/**
 * @author schulteb
 * @version $Revision: 726 $
 * $Date: 2005-02-02 00:50:20 +0100 (Mi, 02 Feb 2005) $
 *
 */
public class ListOperationTest extends TestCase {

	public void testListOperation(){
	 	ArrayList list1 = new ArrayList();
		ArrayList list2 = new ArrayList();
		ArrayList list3 = new ArrayList();
		//teste addInt()
		ListOperation.addInt(list1,1);
		ListOperation.addInt(list2,2);
		ListOperation.addInt(list3,3);
		ListOperation.addInt(list3,4);
		assertEquals(1,((Integer)list1.get(0)).intValue());
		assertEquals(2,((Integer)list2.get(0)).intValue());
		assertEquals(3,((Integer)list3.get(0)).intValue());
		assertEquals(4,((Integer)list3.get(1)).intValue());
		//teste setInt()
		ListOperation.setInt(list3,1,5);
		assertEquals(5,((Integer)list3.get(1)).intValue());
		//teste getInt();
		assertEquals(3,ListOperation.getInt(list3,0));
		assertEquals(2,ListOperation.getInt(list2,0));
		assertEquals(1,ListOperation.getInt(list1,0));
		//teste Double Methoden
		ListOperation.setDouble(list1,0,0.0);
		ListOperation.addDouble(list1,1.0);
		ListOperation.setDouble(list2,0,1.0);
		ListOperation.addDouble(list2,2.0);
		ListOperation.setDouble(list3,0,1.0);
		ListOperation.setDouble(list3,1,2.0);		
		ListOperation.addDouble(list3,3.0);
		ListOperation.addDouble(list3,4.0);
		//teste addDouble(), setDouble()
		assertEquals(0.0,((Double)list1.get(0)).doubleValue(),0.2);
		assertEquals(1.0,((Double)list1.get(1)).doubleValue(),0.2);
		assertEquals(1.0,((Double)list2.get(0)).doubleValue(),0.2);
		assertEquals(2.0,((Double)list2.get(1)).doubleValue(),0.2);
		assertEquals(1.0,((Double)list3.get(0)).doubleValue(),0.2);
		assertEquals(2.0,((Double)list3.get(1)).doubleValue(),0.2);
		assertEquals(3.0,((Double)list3.get(2)).doubleValue(),0.2);
		assertEquals(4.0,((Double)list3.get(3)).doubleValue(),0.2);
		//teste getDouble();
		assertEquals(3.0,ListOperation.getDouble(list3,2),0.2);
		assertEquals(1.0,ListOperation.getDouble(list2,0),0.2);
		assertEquals(1.0,ListOperation.getDouble(list1,1),0.2);	 	
	}

}
