/*
 * Copyright (C) 2005  PG447 - University Dortmund
 * 
 * This file is part of NObELTJE.
 * 
 * NObELTJE is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 * 
 * NObELTJE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with NObELTJE; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

 /*
 * Created on 10.07.2004
 */

package org.nobeltje.tools.io.test;

import junit.framework.TestCase;
import org.nobeltje.tools.io.PropertiesPG;

/**
 * Testklasse fuer tools.io.PropertiesPG.
 * Da tools.io.ArgsInputBeautifier viele dieser Methoden verwendet, wurden die Tests teilweise von dessen TestCase kopiert.
 * 
 * @author $Author: noot $
 * @version $Revision: 726 $
 * $Date: 2005-02-02 00:50:20 +0100 (Mi, 02 Feb 2005) $
 */
public class PropertiesPGTest extends TestCase {

    public void testGetDoubleProperty() {
		PropertiesPG propOK = new PropertiesPG();
		propOK.setProperty("integer","200");
		propOK.setProperty("doubleValue","0.234");
		propOK.setProperty("d","true");
		propOK.setProperty("blubb","true");
		propOK.setProperty("gott","odin");
		
		/* Aufruf ueber eigenes Objekt */
		assertEquals("Standardwert bei Nicht-Vorhanden im gleichen Objekt: ", 0.75, propOK.getDoubleProperty("gibtsnicht",0.75,false), 0);
		assertEquals("Standardwert bei unmoeglichem Casten im gleichen Objekt: ", 0.75, propOK.getDoubleProperty("d",0.75,false), 0);
		assertEquals("Richtiger Wert double im gleichen Objekt: ", 0.234, propOK.getDoubleProperty("doubleValue",0.75,false), 0);
		assertEquals("Richtiger Wert int ohne Nachkommastellen im gleichen Objekt: ", 200, propOK.getDoubleProperty("integer",0.75,false), 0);
		
		/* Aufruf mit fremden Objekt */
		assertEquals("Standardwert bei Nicht-Vorhanden in uebergebenem Objekt: ", 0.75, PropertiesPG.getDoubleProperty(propOK, "gibtsnicht",0.75,false), 0);
		assertEquals("Standardwert bei unmoeglichem Casten in uebergebenem Objekt: ", 0.75, PropertiesPG.getDoubleProperty(propOK, "d",0.75,false), 0);
		assertEquals("Richtiger Wert double in uebergebenem Objekt: ", 0.234, PropertiesPG.getDoubleProperty(propOK, "doubleValue",0.75,false), 0);
		assertEquals("Richtiger Wert int ohne Nachkommastellen in uebergebenem Objekt: ", 200, PropertiesPG.getDoubleProperty(propOK, "integer",0.75,false), 0);

    }

	public void testGetIntProperty() {
		PropertiesPG propOK = new PropertiesPG();
		propOK.setProperty("integer","200");
		propOK.setProperty("doubleValue","3.234");
		propOK.setProperty("doubleValue2","3.534");
		propOK.setProperty("d","true");
		propOK.setProperty("blubb","true");
		propOK.setProperty("gott","odin");

		/* Aufruf ueber eigenes Objekt */
		assertEquals("Standardwert bei Nicht-Vorhanden im gleichen Objekt: ", 232, propOK.getIntProperty("gibtsnicht",232,false));
		assertEquals("Standardwert bei unmoeglichem Casten von Text im gleichen Objekt: ", 232, propOK.getIntProperty("d",232,false));
		assertEquals("Richtiger Wert int im gleichen Objekt: ", 200, propOK.getIntProperty("integer",232,false));
		assertEquals("Richtiger Wert int mit Abrunden im gleichen Objekt: ", 3, propOK.getIntProperty("doubleValue",232,false));
		assertEquals("Richtiger Wert int mit Aufrunden im gleichen Objekt: ", 4, propOK.getIntProperty("doubleValue2",232,false));
		
		/* Aufruf mit fremden Objekt */
		assertEquals("Standardwert bei Nicht-Vorhanden in uebergebenem Objekt: ", 232, PropertiesPG.getIntProperty(propOK, "gibtsnicht",232,false));
		assertEquals("Standardwert bei unmoeglichem Casten von Text im gleichen Objekt: ", 232, propOK.getIntProperty("d",232,false));
		assertEquals("Richtiger Wert int in uebergebenem Objekt: ", 200, PropertiesPG.getIntProperty(propOK, "integer",232,false));
		assertEquals("Richtiger Wert int  mit Abrunden in uebergebenem Objekt: ", 3, PropertiesPG.getIntProperty(propOK, "doubleValue",232,false));
		assertEquals("Richtiger Wert int  mit Aufrunden in uebergebenem Objekt: ", 4, PropertiesPG.getIntProperty(propOK, "doubleValue2",232,false));

	}

	
	public void testGetStringProperty() {
		PropertiesPG propOK = new PropertiesPG();
		propOK.setProperty("integer","200");
		propOK.setProperty("doubleValue","3.234");
		propOK.setProperty("d","true");
		propOK.setProperty("blubb","true");
		propOK.setProperty("gott","odin");

		/* Aufruf ueber eigenes Objekt */
		assertEquals("Standardwert bei Nicht-Vorhanden im gleichen Objekt: ", "swert", propOK.getStringProperty("gibtsnicht","swert",false));
		assertEquals("Richtiger Wert String im gleichen Objekt: ", "odin", propOK.getStringProperty("gott","swert",false));
		
		/* Aufruf mit fremden Objekt */
		assertEquals("Standardwert bei Nicht-Vorhanden in uebergebenem Objekt: ", "swert", PropertiesPG.getStringProperty(propOK, "gibtsnicht","swert",false));
		assertEquals("Richtiger Wert String in uebergebenem Objekt: ", "odin", PropertiesPG.getStringProperty(propOK, "gott","swert",false));

	}

	
}
