/*
 * Copyright (C) 2005  PG447 - University Dortmund
 * 
 * This file is part of NObELTJE.
 * 
 * NObELTJE is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 * 
 * NObELTJE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with NObELTJE; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

 /*
 * Created on 05.07.2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package org.nobeltje.tools.test;

import java.util.Properties;

import junit.framework.TestCase;
import org.nobeltje.tools.io.ArgsInputBeautifier;
import org.nobeltje.exceptions.MalInputFormatException;

/**
 * @author kay
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ArgsInputBeautifierTest extends TestCase {

	/*
	 * Class under test for Properties beautify(String[])
	 */
	public void testBeautifyStringArray() {
		String [] testOK = {"-x","200","-testfkt","FonsecaF1","-d","-blubb","-gott","odin"};
		String [] testFalse = {"-1234","thor","tyr","Fenster"};
		Properties propOK = new Properties();
		propOK.setProperty("x","200");
		propOK.setProperty("testfkt","FonsecaF1");
		propOK.setProperty("d","true");
		propOK.setProperty("blubb","true");
		propOK.setProperty("gott","odin");
		try 
		{
			assertEquals("Korrektes auseinandernehmen von args[]: ",propOK,ArgsInputBeautifier.beautify(testOK));
		} 
		catch (MalInputFormatException e) 
		{
			e.printStackTrace();
		}
		try
		{
			ArgsInputBeautifier.beautify(testFalse);
			fail("Keine Exception geworfen");
		}
		catch (MalInputFormatException e) 
		{
			//e.printStackTrace();
		}
	}

	/*
	 * Class under test for Properties beautify(Properties, String[])
	 */
	public void testBeautifyPropertiesStringArray() {
		String [] testOK = {"-x","200","-testfkt","FonsecaF1","-d","-blubb","-gott","odin"};
		String [] testFalse = {"-1234","thor","tyr","Fenster"};
		Properties propOK = new Properties();
		propOK.setProperty("x","200");
		propOK.setProperty("testfkt","FonsecaF1");
		propOK.setProperty("d","true");
		propOK.setProperty("blubb","true");
		propOK.setProperty("gott","odin");
		try 
		{
			assertEquals("Korrektes auseinandernehmen von args[]: ",propOK,ArgsInputBeautifier.beautify(new Properties(),testOK));
		} 
		catch (MalInputFormatException e) 
		{
			e.printStackTrace();
		}
		try
		{
			ArgsInputBeautifier.beautify(new Properties(),testFalse);
			fail("Keine Exception geworfen");
		}
		catch (MalInputFormatException e) 
		{
			//e.printStackTrace();
		}
	}

	
	/*
	 * Class under test for boolean saveArgsToFile(Properties, String)
	 */
	public void testSaveArgsToFilePropertiesString() {
		String [] testOK = {"-x","200","-testfkt","FonsecaF1","-d","-blubb","-gott","odin"};
		String [] testFalse = {"-1234","thor","tyr","Fenster"};
		Properties propOK = new Properties();
		propOK.setProperty("x","200");
		propOK.setProperty("testfkt","FonsecaF1");
		propOK.setProperty("d","true");
		propOK.setProperty("blubb","true");
		propOK.setProperty("gott","odin");
		ArgsInputBeautifier.saveArgsToFile(testOK,"testsave.dat");
		assertEquals("Laden und Speichern von props", propOK, ArgsInputBeautifier.getArgsFromFile("testsave.dat"));
	}

	/*
	 * Class under test for boolean saveArgsToFile(String[], String)
	 */
	public void testSaveArgsToFileStringArrayString() {
		String [] testOK = {"-x","200","-testfkt","FonsecaF1","-d","-blubb","-gott","odin"};
		String [] testFalse = {"-1234","thor","tyr","Fenster"};
		Properties propOK = new Properties();
		propOK.setProperty("x","200");
		propOK.setProperty("testfkt","FonsecaF1");
		propOK.setProperty("d","true");
		propOK.setProperty("blubb","true");
		propOK.setProperty("gott","odin");
		ArgsInputBeautifier.saveArgsToFile(propOK,"testsave.dat");
		assertEquals("Laden und Speichern von args",propOK,ArgsInputBeautifier.getArgsFromFile("testsave.dat"));
		
	}

	public void testGetDoubleProperty() {
		String [] testOK = {"-integer","200","-doubleValue","0.234","-d","-blubb","-gott","odin"};
		String [] testFalse = {"-1234","thor","tyr","Fenster"};
		Properties propOK = new Properties();
		propOK.setProperty("integer","200");
		propOK.setProperty("doubleValue","FonsecaF1");
		propOK.setProperty("d","true");
		propOK.setProperty("blubb","true");
		propOK.setProperty("gott","odin");
		try 
		{
			Properties tester = ArgsInputBeautifier.beautify(testOK);
			assertEquals("Double vergleich: ",0.234,ArgsInputBeautifier.getDoubleProperty(tester,"doubleValue",0.75,true),0);
			assertEquals("Double vergleich: ",0.75,ArgsInputBeautifier.getDoubleProperty(tester,"blubb",0.75,false),0);
		}
		catch (MalInputFormatException e) 
		{
			e.printStackTrace();
		}
	}

	public void testGetIntProperty() {
		String [] testOK = {"-integer","200","-doubleValue","0.234","-d","-blubb","-gott","odin","-bigDouble","24.6"};
		String [] testFalse = {"-1234","thor","tyr","Fenster"};
		Properties propOK = new Properties();
		propOK.setProperty("integer","200");
		propOK.setProperty("doubleValue","FonsecaF1");
		propOK.setProperty("d","true");
		propOK.setProperty("blubb","true");
		propOK.setProperty("gott","odin");
		try 
		{
			Properties tester = ArgsInputBeautifier.beautify(testOK);
			assertEquals("Integer vergleich: ",200,ArgsInputBeautifier.getIntProperty(tester,"integer",2,true),0);
			assertEquals("Integer vergleich: ",2,ArgsInputBeautifier.getIntProperty(tester,"blubb",2,false),0);
			assertEquals("Doubel als Int holen: ",0,ArgsInputBeautifier.getIntProperty(tester,"doubleValue",42,true));
			assertEquals("Doubel als Int holen: ",25,ArgsInputBeautifier.getIntProperty(tester,"bigDouble",42,true));
		}
		catch (MalInputFormatException e) 
		{
			e.printStackTrace();
		}
	}

	public void testGetStringProperty() {
		String [] testOK = {"-integer","200","-doubleValue","0.234","-d","-blubb","-gott","odin"};
		String [] testFalse = {"-1234","thor","tyr","Fenster"};
		Properties propOK = new Properties();
		propOK.setProperty("integer","200");
		propOK.setProperty("doubleValue","FonsecaF1");
		propOK.setProperty("d","true");
		propOK.setProperty("blubb","true");
		propOK.setProperty("gott","odin");
		try 
		{
			Properties tester = ArgsInputBeautifier.beautify(testOK);
			assertEquals("String vergleich: ","odin",ArgsInputBeautifier.getStringProperty(tester,"gott","loki",true));
			assertEquals("STring vergleich: ","loki",ArgsInputBeautifier.getStringProperty(tester,"gibbetnischt","loki",false));
		}
		catch (MalInputFormatException e) 
		{
			e.printStackTrace();
		}
	}

}
