/*
 * Copyright (C) 2005  PG447 - University Dortmund
 * 
 * This file is part of NObELTJE.
 * 
 * NObELTJE is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 * 
 * NObELTJE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with NObELTJE; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

 /*
 * Created on 07.07.2004
 */
package org.nobeltje.tools.test;

import java.util.ArrayList;
import java.util.List;

import junit.framework.TestCase;
import org.nobeltje.tools.io.FileParser;

/**
 * @author $Author: noot $
 * @version $Revision: 726 $
 * $Date: 2005-02-02 00:50:20 +0100 (Mi, 02 Feb 2005) $
 */
public class FileParserTest extends TestCase {
	String fileName = "tools/test/FileParserTest.dat";
	List list = new ArrayList();
	
	public void testParseFile() {
		// Teste, ob eine Exception geworfen wird, wenn die Datei nicht existiert
		try {
			FileParser.parseFile("dummy", list);
			fail();
		}
		catch (Exception e) {}

		// Teste, ob eine Exception geworfen wird, wenn das 2. Argument ungueltig ist
		try {
			FileParser.parseFile(fileName, null);
			fail();
		}
		catch (Exception e) {}

		try {
			FileParser.parseFile(fileName, list);
		}
		catch (Exception e) {
			e.printStackTrace();
		}

		// Teste, ob die Liste 2 Vektoren enth?lt (siehe FileParserTest.dat)
		assertEquals(2, list.size());
		// Teste, ob jeder Vektor 2 Double Werte enth?lt
		assertEquals(2, ((ArrayList)list.get(0)).size());
		assertEquals(2, ((ArrayList)list.get(1)).size());

		// Teste die einzelnen Werte (siehe FileParserTest.dat)
		System.out.println(list);
		assertEquals(0.12345, ((Double)((ArrayList)list.get(0)).get(0)).doubleValue(), 0.0);
		assertEquals(9.87654, ((Double)((ArrayList)list.get(0)).get(1)).doubleValue(), 0.0);
		assertEquals(0.0005, ((Double)((ArrayList)list.get(1)).get(0)).doubleValue(), 0.0);
		assertEquals(42, ((Double)((ArrayList)list.get(1)).get(1)).doubleValue(), 0.0);
	}
}
