/*
 * Copyright (C) 2005  PG447 - University Dortmund
 * 
 * This file is part of NObELTJE.
 * 
 * NObELTJE is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 * 
 * NObELTJE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with NObELTJE; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

 /*
 * Created on 01.06.2004
 *
 * TestCase fuer die Klasse tools.ParetoDomination
 * Sie soll u.a. als Beispiel dienen, wie TestCases generiert werden
 * Eclipse hilft dabei: Neu/Andere/Java/JUnit/JUnit Test Case
 */

package org.nobeltje.tools.test;

import java.util.ArrayList;

import junit.framework.TestCase;
import org.nobeltje.tools.ParetoDomination;

/**
 * @author $Author: noot $
 * @version $Revision: 726 $
 * $Date: 2005-02-02 00:50:20 +0100 (Mi, 02 Feb 2005) $
 */

public class ParetoDominationTest extends TestCase {
	
	public void testNonDominated() {
		// Versuchsparameter generieren
		ArrayList list1 = new ArrayList();
		ArrayList list2 = new ArrayList();
		// Versuche durchfuehren
		
		// Test 0 auf leere Individuum ... soll der eine Exception werfen?
		list1.clear();
		list2.clear();
		assertEquals("Test auf leere: ", true, org.nobeltje.tools.ParetoDomination.nonDominated(list1, list2));
		
		// Test 1 auf gleiche eindimensionale Individuen
		list1.clear();
		list2.clear();
		list1.add(new Double(0));
		list2.add(new Double(0));
		assertEquals("Test auf gleiche 1-D: ", true, ParetoDomination.nonDominated(list1, list2));
		assertEquals("Test auf gleiche 1-D fuer int-Methode: ", ParetoDomination.DOMINATION_EQUAL, ParetoDomination.checkDomination(list1, list2));
		// Test 2 auf gleiche mehrdimensionale Individuen
		list1.clear();
		list2.clear();
		list1.add(new Double(0));
		list2.add(new Double(0));
		list1.add(new Double(-4));
		list2.add(new Double(-4));
		list1.add(new Double(7.23));
		list2.add(new Double(7.23));
		list1.add(new Double(2));
		list2.add(new Double(2));
		list1.add(new Double(-111.55));
		list2.add(new Double(-111.55));
		assertEquals("Test auf gleiche x-D", true, ParetoDomination.nonDominated(list1, list2));
		assertEquals("Test auf gleiche x-D fuer int-Methode: ", ParetoDomination.DOMINATION_EQUAL, ParetoDomination.checkDomination(list1, list2));

		// Test 3 auf nicht vergleichbare (zwangslaeufig mehrdimensionale) Individuen
		list1.clear();
		list2.clear();
		list1.add(new Double(2));
		list1.add(new Double(1));
		list2.add(new Double(1));
		list2.add(new Double(2));
		assertEquals("Test auf nicht vergleichbar: ",
				     true, 
					 ParetoDomination.nonDominated(list1, list2));
		assertEquals("Test auf nicht Vergleichbarkeit bei der int-Methode: ",
							 ParetoDomination.DOMINATION_NONE, 
							 ParetoDomination.checkDomination(list1, list2));

		// Test 4 auf Individuen (a) dominierend (b)
		list1.clear();
		list2.clear();
		list1.add(new Double(1));
		list1.add(new Double(1));
		list2.add(new Double(1));
		list2.add(new Double(2));
		assertEquals("A dominiert B: ", false, ParetoDomination.nonDominated(list1, list2));
		assertEquals("A dominiert B bei der int-Methode: ", ParetoDomination.DOMINATION_IND1, ParetoDomination.checkDomination(list1, list2));
		
		// Test 5 auf Individuen (b) dominierend (a)
		list1.clear();
		list2.clear();
		list1.add(new Double(1));
		list1.add(new Double(3));
		list2.add(new Double(1));
		list2.add(new Double(0));
		assertEquals("B dominiert A: ", true, ParetoDomination.nonDominated(list1, list2));
		assertEquals("B dominiert A bei der int-Methode: ", ParetoDomination.DOMINATION_IND2, ParetoDomination.checkDomination(list1, list2));

	}
}
