/*
 * Copyright (C) 2005  PG447 - University Dortmund
 * 
 * This file is part of NObELTJE.
 * 
 * NObELTJE is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 * 
 * NObELTJE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with NObELTJE; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

 /*
 * Created on 07.07.2004
 */
package org.nobeltje.tools.test;

import java.util.ArrayList;
import java.util.Random;

import junit.framework.TestCase;
import org.nobeltje.tools.Particle;

/**
 * @author jens
 *
 * @author $Author: noot $
 * @version $Revision: 726 $
 * $Date: 2005-02-02 00:50:20 +0100 (Mi, 02 Feb 2005) $
 */
public class ParticleTest extends TestCase {
	Particle p = new Particle();

	public void testConstruction() {
		// Teste, ob fuer jedes Attribut des Partikels eine ArrayList angelegt wurde
		assertNotNull(p.getPosition());
		assertNotNull(p.getVelocity());
		assertNotNull(p.getPBest());
		assertNotNull(p.getFitness());
		assertNotNull(p.getPBestFit());
	}

	public void testUpdatePosition() {
		ArrayList position	= new ArrayList(3);
		ArrayList velocity	= new ArrayList(3);
		ArrayList tempSum	= new ArrayList(3);
		Random rand			= new Random();;

		// Fuelle Position und Geschwindigkeitsvektor des Partikels mit Zufallswerten
		// Speichere die Summe der beiden Werte in 'tempSum'
		for (int i = 0; i < 3; i++) {
			p.getPosition().add(new Double(rand.nextDouble()));
			p.getVelocity().add(new Double(rand.nextDouble()));
			tempSum.add(new Double(((Double)p.getPosition().get(i)).doubleValue() +
									((Double)p.getVelocity().get(i)).doubleValue()));
		}

		p.updatePosition();

		for (int i = 0; i < p.getPosition().size(); i++)
			assertEquals(tempSum.get(i), p.getPosition().get(i));
	}
}
