/*
 * Copyright (C) 2005  PG447 - University Dortmund
 * 
 * This file is part of NObELTJE.
 * 
 * NObELTJE is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 * 
 * NObELTJE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with NObELTJE; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

 /*
 * Created on Jul 6, 2004
 *
 */
package org.nobeltje.tools.test;

import junit.framework.TestCase;
import org.nobeltje.tools.RandomPG;
import org.nobeltje.exceptions.InvalidBoundException;


/**
 * Testet die Korrektheit der Klasse tools.RandomPG.
 * 
 * @author $Author: noot $
 * @version $Revision: 726 $
 * $Date: 2005-02-02 00:50:20 +0100 (Mi, 02 Feb 2005) $
 * 
 * @see tools.RandomPG
 */

public class RandomPGTest extends TestCase{
	
	/**
	 * Testet die Methode nextDouble().
	 *
	 */
	public void testNextDouble() {
		RandomPG randomizer = new RandomPG();
		int negative = 0;
		double number;
		for(int i=0; i<1000; i++) {
			try {
				number = randomizer.nextDouble(-10, 10);
				System.out.println(number);
				
				// werden Grenzen eingehalten?
				assertTrue("lowerBound: ",  number>-10);
				assertTrue("upperBound: ",  number<10);
				if (number<0) negative++;
			} catch (InvalidBoundException e) {
				e.printStackTrace();
			}
		}
		System.out.println(negative);
	}
	
	/**
	 * Testet die Methoden setSeed(long seed), getSeed() und die Konstruktoren
	 * RandomPG(), RandomPG(long seed).
	 *
	 */
	public void testSeed() {
		
		// leerer Konstruktor
		RandomPG randomizer = new RandomPG();
		System.out.println(randomizer.getSeed());
		
		// seed mit setSeed(long seed) gesetzt
		long seed = 43;
		randomizer.setSeed(seed);
		assertEquals("seed", seed, randomizer.getSeed());
		
		// seed per Konstruktor RandomPG(long seed) gesetzt
		RandomPG randomizer2 = new RandomPG(42);
		assertEquals("seed", 42, randomizer2.getSeed());
	}
}
